# define SIZE	1000

void start(int times, int revolutions, string report)
{
    call_out("test", 0, times, revolutions,
	     ({ previous_object(), report, millitime() }));
}

static void test(int times, int revolutions, mixed *data)
{
    if (times != 0) {
	int *a, i, j;

	for (i = 0; i < revolutions; i++) {
	    a = allocate_int(SIZE);
	    for (j = 0; j < SIZE; j++) {
		a[j] = j;
	    }
	}
	call_out("test", 0, times - 1, revolutions, data);
    } else {
	call_out("stop", 0, data);
    }
}

static void stop(mixed *data)
{
    object report_obj;
    string report_func;
    mixed *start_time;

    ({ report_obj, report_func, start_time }) = data;
    call_other(report_obj, report_func, start_time, millitime());
}
